#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.Streams;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "StreamSync", Category = "Test", Help = "Basic template with one value in/out", Tags = "c#")]
	#endregion PluginInfo
	public class TestStreamSyncNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", AutoValidate = false)]
		public IInStream<double> FInput;

		[Input("Sync", DefaultBoolean = true)]
		public ISpread<bool> FSync;
		
		
		[Output("Output")]
		public IOutStream<double> FOutput;

		int FCount;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			if (FSync[0])
			{
				FInput.Sync();
				FCount = FInput.Length;
			}
			
			FOutput.Length = FCount;
			int i=0;
			using (var r = FInput.GetReader())
			using (var w = FOutput.GetWriter())
			{
				while (i<FCount)
				{
					w.Write(r.Read());
					i++;
				}
			}
		}
	}
}
